#include <stdio.h>
#include <string.h>
#include <math.h>
#define NLOCI 50
#define NALLE 100
#define NPOP  20
#define NIND  500

main(argc,argv)
int argc;
char **argv;
{
FILE *fp=stdin,*fpo=stdout;
int i,j,k,l,indcount[NIND],n,rn,nind,flg,npop,popsz[20],nloci,nallele[NLOCI];
char indname[NIND][10],bf[100],b[20],b1[20],b2[20],popname[20][10],b3[20],
b4[20];
char allele[NLOCI][NALLE][10],loci[NLOCI][10],bw[10];
float freq[NLOCI][NALLE][NPOP],fw;
int samplesz[NLOCI][NPOP],locia,allelea1,allelea2,popa,iw,iw1,ns,tflg;
int ifc,fin,indflg;


  ifc=fin=0;
  tflg=1;
  indflg=0;
  for(i=0; i< NLOCI ; i++){
    for(j=0; j<NPOP ; j++) samplesz[i][j]=0;
  }

  for(i=0; i<NLOCI ; i++){
    for(j=0; j<NALLE ; j++){
     for(k=0; k<10 ; k++) nallele[i]=0;
     for(k=0; k<npop ; k++) freq[i][j][k]=0.;
   }
  }
  for(i=0; i<NLOCI ; i++) {
    nallele[i]=0;
    for( j=0; j<10 ; j++) loci[i][j]=0;
  }

	if( argc == 1 ){
	  printf("cnvdat inputfile -o [output file]\n");
          printf("MAXPOP %d\n",NPOP);
          printf("MAXLOCI %d\n",NLOCI);
          printf("MAX ALLELE %d\n",NALLE);
          printf("MAX INDIVIDUAL %d\n",NIND);
	  exit(1);
	}

	for(i=1; i< argc ; i++){
	  /* printf("i=%d\n",i); fflush(stdout);  */
	  if( argv[i][0] == '-' ){
		switch( argv[i][1]){
		 case 'o' : if( argv[i][2] != 0 ){
						  if( (fpo=fopen(argv[i]+2,"w")) == NULL ){
							fprintf(stderr,"Can't open output-file:%s\n",argv[i]+2);
							exit(1);
							}
							break;
							}
						  if((fpo=fopen(argv[i+1],"w")) == NULL ) {
						  fprintf(stderr,"Can't open output-file:%s\n",argv[i+1]);
						  exit(1);
						}
						i++;
						break;
                 case 'i': indflg=1;
                           break;
		 default :  fprintf(stderr,"invalid argument",argv[i]);
						exit(1);
		}
	  }else{
		if((fp=fopen(argv[i],"r")) == NULL ){
					 fprintf(stderr,"Can't open input-file:%s\n",argv[i]);
					 exit(1);
		}
		fin=i;
		ifc++;
		/* printf("fin=%d\n"); fflush(stdout); */

	  }
	}


  if( ifc == 0 ){
		fprintf(stderr,"no input-file\n");
		exit(1);
	}





  for(i=0; i< NIND ; i++) {
    indcount[i]=0;
    for(j=0; j<10 ; j++) indname[i][j]=0;
   }

  for(i=0; i<20 ; i++){
    for(j=0; j<10 ; j++) popname[i][j]=0;
  }

  nind=0;
  npop=0;
  nloci=0;
  for( ; ; ){
   rn=rdline(fp,bf,&n);
   if( rn == -1 && n == 0 ) break;
   if( rn == 1 ) continue;
   for(i=0; i<20 ; i++){
     b[i]=b1[i]=b2[i]=b3[i]=b4[i]=0;
   }
   sscanf(bf,"%s %s %s %s %s",b,b1,b2,b3,b4);
      
   if( indflg == 1 ){
     for(j=0; j< nind ; j++){
    if( strcmp(indname[j],b2) == 0 ){
      indcount[j]++;
      flg=1;
      break;
    }
   }
   if( flg == 0  ){
     strcpy(indname[nind],b2);
     nind++;
  
   }
   }
   locia=-1;
   allelea1=-1;
   allelea2=-1;
   popa=-1;
   for(j=0; j< nloci ; j++){
     if( strcmp(loci[j],b1) == 0 ){
       locia=j;
       break;
     }
   }
   if( locia == -1 ){
      strcpy(loci[nloci],b1);
      locia=nloci;
      nloci++;
    }

/*  printf("locia=%d nloci=%d\n",locia,nloci); fflush(stdout); */
  for(j=0; j< nallele[locia] ; j++){
   if( strcmp(allele[locia][j],b3) == 0 ){
     allelea1=j;
     break;
   }
 }


  if( allelea1 == -1 ){
    strcpy(allele[locia][nallele[locia]],b4);
    allelea1 = nallele[locia];
    nallele[locia]++;
  }

  allelea2 = -1;
  for(j=0; j< nallele[locia] ; j++){
   if( strcmp(allele[locia][j],b4) == 0 ){
     allelea2 = j;
     break;
   }
 }
  if( allelea2 == -1 ){
    strcpy(allele[locia][nallele[locia]],b4);
    allelea2 = nallele[locia];
    nallele[locia]++;
  }


/*  printf("allelea=%d nallele=%d\n",allelea,nallele[locia]); fflush(stdout); */
  for(j=0; j<npop ; j++){
    if( strncmp(popname[j],b,strlen(b)) == 0 ){
      popa=j;
      break;
    }
  }
  if( popa == -1 ){
     strcpy(popname[npop],b);
     popa = npop;
     npop++;
   }
/*   printf("locia =%d allelea=%d popa=%d\n",locia,allelea,popa);
   fflush(stdout);
*/

   freq[locia][allelea1][popa] += 1.0;
   freq[locia][allelea2][popa] += 1.0;
/*   printf("freq\n"); fflush(stdout); */
    samplesz[locia][popa] += 2;
      popsz[popa] += 2;
/*   printf("samplen"); fflush(stdout); */
  }

ns=0;

for(i=0; i<nloci ; i++){
  for(j=0; j< nallele[i] ; j++){
    for(k= j+1 ; k< nallele[i] ; k++){
        sscanf(allele[i][j],"%d",&iw);
        sscanf(allele[i][k],"%d",&iw1);      
        if( iw > iw1 ){
          strcpy(bw,allele[i][j]);
          strcpy(allele[i][j],allele[i][k]);
          strcpy(allele[i][k],bw);
          for(l=0; l<npop ; l++){
            fw = freq[i][j][l];
            freq[i][j][l] = freq[i][k][l];
            freq[i][k][l] = fw;
	  }
	}
   
      }
  }
}


 

 fprintf(fpo,"%d populations\n",npop); 
 for(i=0; i<npop ; i++) {
    fprintf(fpo,"%d %s\n",i+1,popname[i]);
  }

 for(i=0; i<npop ; i++) {
    fprintf(stderr,"%d %s %d\n",i+1,popname[i],popsz[i]);
  }


for(i=0; i< nloci ; i++){
  iw=0;
  fprintf(fpo,"@locus %d %s\n",i+1,loci[i]);
  for(j=0; j<nallele[i] ; j++){
    fprintf(fpo,"%4s * ",allele[i][j]);
    for(k=0; k<npop ; k++){
      freq[i][j][k] /= samplesz[i][k];
      fprintf(fpo," %1.4f",freq[i][j][k]);
    }
    fprintf(fpo,"\n");
  }
  fprintf(fpo,"#      ");
  for(k=0; k<npop ; k++){
     fprintf(fpo,"    %3d",samplesz[i][k]);
     ns += samplesz[i][k];
     iw += samplesz[i][k];
   }
   fprintf(fpo,"\n");
  /*  if( tflg == 1 ) printf("  ttl=%d\n",iw);*/
   
}

fprintf(stderr,"total sample %d\n",ns);
if( indflg == 1 ) fprintf(stderr,"total individual %d\n",nind);
exit(0);
}
rdline(fp,bf,n)
FILE *fp;
char *bf;
int *n;
{
int i,cw,n1;
*n=0;
for(i=0; i<100 ; i++) bf[i]=0;

n1=0;
for( ; ; ){
  cw = getc(fp);
  if( cw == EOF ) return(-1);
  bf[n1]=cw;
  n1++;
  if( cw != ' ' && cw != '\n' && cw != '\t') (*n)++;
  if( cw == '\n' ) {
     if( n1 > 0 ) return(0);
     return(1);
   }
   
}


}



